import { MyoManager } from "./MyoManager";
import { IRssiDto, IBatteryDto, IArmDto, IOrientationDto, IPoseDto, Direction, Pose, Arm, VibrationDuration } from "./types";
import { Quaternion, IIMUData } from "./util";
export declare class Myo {
    macAddress: string;
    name: string;
    connectIndex: string;
    myoManager: MyoManager;
    constructor(macAddress: string, name: string, connectIndex: string, myoManager: MyoManager);
    isLocked: boolean;
    isConnected: boolean;
    isSynced: boolean;
    connectVersion: string | undefined;
    warmupState: string | undefined;
    batteryLevel: number;
    direction: Direction | undefined;
    arm: Arm | undefined;
    orientationOffset: Quaternion;
    lastQuant: Quaternion;
    lastIMU: IIMUData | undefined;
    lastPose: Pose | undefined;
    lock(): void;
    unlock(hold?: boolean): void;
    zeroOrientation(): void;
    vibrate(duration?: VibrationDuration): void;
    requestBluetoothStrength(): void;
    requestBatteryLevel(): void;
    streamEMG(enabled: boolean): void;
    pose(data: IPoseDto): void;
    orientation(data: IOrientationDto): void;
    syncArm(data: IArmDto): void;
    unsyncArm(): void;
    updateBluetooth(data: IRssiDto): void;
    updateBatteryLevel(data: IBatteryDto): void;
}
